Index: drivers/net/wan/hdlc_ppp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/hdlc_ppp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/hdlc_ppp.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/hdlc_ppp.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -2,15 +2,13 @@
  * Generic HDLC support routines for Linux
  * Point-to-point protocol support
  *
- * Copyright (C) 1999 - 2001 Krzysztof Halasa <khc@pm.waw.pl>
+ * Copyright (C) 1999 - 2003 Krzysztof Halasa <khc@pm.waw.pl>
  *
  * This program is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * under the terms of version 2 of the GNU General Public License
+ * as published by the Free Software Foundation.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/slab.h>
@@ -68,10 +66,10 @@
 
 
 
-static void ppp_rx(struct sk_buff *skb)
+static unsigned short ppp_type_trans(struct sk_buff *skb,
+				     struct net_device *dev)
 {
-	skb->protocol = htons(ETH_P_WAN_PPP);
-	netif_rx(skb);
+	return __constant_htons(ETH_P_WAN_PPP);
 }
 
 
@@ -103,7 +101,8 @@
 
 		hdlc->open = ppp_open;
 		hdlc->stop = ppp_close;
-		hdlc->netif_rx = ppp_rx;
+		hdlc->netif_rx = NULL;
+		hdlc->type_trans = ppp_type_trans;
 		hdlc->proto = IF_PROTO_PPP;
 		dev->hard_start_xmit = hdlc->xmit;
 		dev->hard_header = NULL;
Index: drivers/net/wan/hdlc_raw.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/hdlc_raw.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/hdlc_raw.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/hdlc_raw.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -2,15 +2,13 @@
  * Generic HDLC support routines for Linux
  * HDLC support
  *
- * Copyright (C) 1999 - 2001 Krzysztof Halasa <khc@pm.waw.pl>
+ * Copyright (C) 1999 - 2003 Krzysztof Halasa <khc@pm.waw.pl>
  *
  * This program is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * under the terms of version 2 of the GNU General Public License
+ * as published by the Free Software Foundation.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/slab.h>
@@ -26,10 +24,10 @@
 #include <linux/hdlc.h>
 
 
-static void raw_rx(struct sk_buff *skb)
+static unsigned short raw_type_trans(struct sk_buff *skb,
+				     struct net_device *dev)
 {
-	skb->protocol = htons(ETH_P_IP);
-	netif_rx(skb);
+	return __constant_htons(ETH_P_IP);
 }
 
 
@@ -67,7 +65,7 @@
 			new_settings.encoding = ENCODING_NRZ;
 
 		if (new_settings.parity == PARITY_DEFAULT)
-			new_settings.parity = PARITY_NONE;
+			new_settings.parity = PARITY_CRC16_PR1_CCITT;
 
 		result = hdlc->attach(hdlc, new_settings.encoding,
 				      new_settings.parity);
@@ -79,11 +77,13 @@
 
 		hdlc->open = NULL;
 		hdlc->stop = NULL;
-		hdlc->netif_rx = raw_rx;
+		hdlc->netif_rx = NULL;
+		hdlc->type_trans = raw_type_trans;
 		hdlc->proto = IF_PROTO_HDLC;
 		dev->hard_start_xmit = hdlc->xmit;
 		dev->hard_header = NULL;
 		dev->type = ARPHRD_RAWHDLC;
+		dev->flags = IFF_POINTOPOINT | IFF_NOARP;
 		dev->addr_len = 0;
 		return 0;
 	}
Index: drivers/net/wan/hdlc_x25.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/hdlc_x25.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/hdlc_x25.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/hdlc_x25.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -2,15 +2,13 @@
  * Generic HDLC support routines for Linux
  * X.25 support
  *
- * Copyright (C) 1999 - 2001 Krzysztof Halasa <khc@pm.waw.pl>
+ * Copyright (C) 1999 - 2003 Krzysztof Halasa <khc@pm.waw.pl>
  *
  * This program is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * under the terms of version 2 of the GNU General Public License
+ * as published by the Free Software Foundation.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/slab.h>
@@ -204,6 +202,7 @@
 		hdlc->open = x25_open;
 		hdlc->stop = x25_close;
 		hdlc->netif_rx = x25_rx;
+		hdlc->type_trans = NULL;
 		hdlc->proto = IF_PROTO_X25;
 		dev->hard_start_xmit = x25_xmit;
 		dev->hard_header = NULL;
Index: drivers/net/wan/n2.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/n2.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/n2.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/n2.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -1,12 +1,11 @@
 /*
  * SDL Inc. RISCom/N2 synchronous serial card driver for Linux
  *
- * Copyright (C) 1998-2002 Krzysztof Halasa <khc@pm.waw.pl>
+ * Copyright (C) 1998-2003 Krzysztof Halasa <khc@pm.waw.pl>
  *
  * This program is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * under the terms of version 2 of the GNU General Public License
+ * as published by the Free Software Foundation.
  *
  * For information see http://hq.pm.waw.pl/hdlc/
  *
@@ -17,7 +16,6 @@
  *    SDL Inc. PPP/HDLC/CISCO driver
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/slab.h>
@@ -34,14 +32,24 @@
 #include "hd64570.h"
 
 
-static const char* version = "SDL RISCom/N2 driver version: 1.10";
+static const char* version = "SDL RISCom/N2 driver version: 1.14";
 static const char* devname = "RISCom/N2";
 
+#undef DEBUG_PKT
+#define DEBUG_RINGS
+
 #define USE_WINDOWSIZE 16384
 #define USE_BUS16BITS 1
 #define CLOCK_BASE 9830400	/* 9.8304 MHz */
-
+#define MAX_PAGES      16	/* 16 RAM pages at max */
+#define MAX_RAM_SIZE 0x80000	/* 512 KB */
+#if MAX_RAM_SIZE > MAX_PAGES * USE_WINDOWSIZE
+#undef MAX_RAM_SIZE
+#define MAX_RAM_SIZE (MAX_PAGES * USE_WINDOWSIZE)
+#endif
 #define N2_IOPORTS 0x10
+#define NEED_DETECT_RAM
+#define MAX_TX_BUFFERS 10
 
 static char *hw = NULL;	/* pointer to hw=xxx command line string */
 
@@ -86,16 +94,16 @@
 	struct card_s *card;
 	spinlock_t lock;	/* TX lock */
 	sync_serial_settings settings;
+	int valid;		/* port enabled */
+	int rxpart;		/* partial frame received, next frame invalid*/
 	unsigned short encoding;
 	unsigned short parity;
+	u16 rxin;		/* rx ring buffer 'in' pointer */
+	u16 txin;		/* tx ring buffer 'in' and 'last' pointers */
+	u16 txlast;
 	u8 rxs, txs, tmc;	/* SCA registers */
-	u8 valid;		/* port enabled */
 	u8 phy_node;		/* physical port # - 0 or 1 */
 	u8 log_node;		/* logical port # */
-	u8 rxin;		/* rx ring buffer 'in' pointer */
-	u8 txin;		/* tx ring buffer 'in' and 'last' pointers */
-	u8 txlast;
-	u8 rxpart;		/* partial frame received, next frame invalid*/
 }port_t;
 
 
@@ -106,8 +114,9 @@
 	u32 ram_size;		/* number of bytes */
 	u16 io;			/* IO Base address */
 	u16 buff_offset;	/* offset of first buffer of first channel */
+	u16 rx_ring_buffers;	/* number of buffers in a ring */
+	u16 tx_ring_buffers;
 	u8 irq;			/* IRQ (3-15) */
-	u8 ring_buffers;	/* number of buffers in a ring */
 
 	port_t ports[2];
 	struct card_s *next_card;
@@ -216,7 +225,7 @@
 	MOD_INC_USE_COUNT;
 	mcr &= port->phy_node ? ~DTR_PORT1 : ~DTR_PORT0; /* set DTR ON */
 	outb(mcr, io + N2_MCR);
-  
+
 	outb(inb(io + N2_PCR) | PCR_ENWIN, io + N2_PCR); /* open window */
 	outb(inb(io + N2_PSR) | PSR_DMAEN, io + N2_PSR); /* enable dma */
 	sca_open(hdlc);
@@ -250,7 +259,7 @@
 	hdlc_device *hdlc = dev_to_hdlc(dev);
 	port_t *port = hdlc_to_port(hdlc);
 
-#ifdef CONFIG_HDLC_DEBUG_RINGS
+#ifdef DEBUG_RINGS
 	if (cmd == SIOCDEVPRIVATE) {
 		sca_dump_rings(hdlc);
 		return 0;
@@ -297,62 +306,6 @@
 
 
 
-static u8 n2_count_page(card_t *card)
-{
-	u8 page;
-	int i, bcount = USE_WINDOWSIZE, wcount = USE_WINDOWSIZE/2;
-	u16 *dp = (u16*)card->winbase;
-	u8 *bp = (u8*)card->winbase;
-	u8 psr = inb(card->io + N2_PSR) & PSR_WINBITS;
-
-
-	for (page = 0; page < 16; page++) {
-		outb(psr | page, card->io + N2_PSR); /* select a page */
-		writeb(page, dp);
-		if (readb(dp) != page)
-			break;	/* If can't read back, no good memory */
-
-		outb(psr, card->io + N2_PSR); /* goto page 0 */
-		if (readb(dp))
-			break;	/* If page 0 changed, then wrapped around */
-
-		outb(psr | page, card->io + N2_PSR); /* select page again */
-
-		/*  first do byte tests */
-		for (i = 0; i < bcount; i++)
-			writeb(i, bp + i);
-		for (i = 0; i < bcount; i++)
-			if (readb(bp + i) != (i & 0xff))
-				return 0;
-
-		for (i = 0; i < bcount; i++)
-			writeb(~i, bp + i);
-		for (i = 0; i < bcount; i++)
-			if (readb(bp + i) != (~i & 0xff))
-				return 0;
-
-		/* next do 16-bit tests */
-		for (i = 0; i < wcount; i++)
-			writew(0x55AA, dp + i);
-		for (i = 0; i < wcount; i++)
-			if (readw(dp + i) != 0x55AA)
-				return 0;
-
-		for (i = 0; i < wcount; i++)
-			writew(0xAA55, dp + i);
-		for (i = 0; i < wcount; i++)
-			if (readw(dp + i) != 0xAA55)
-				return 0;
-
-		for (i = 0; i < wcount; i++)
-			writew(page, dp + i);
-	}
-
-	return page;
-}
-
-
-
 static void n2_destroy_card(card_t *card)
 {
 	int cnt;
@@ -376,11 +329,12 @@
 
 
 
-static int n2_run(unsigned long io, unsigned long irq, unsigned long winbase,
-		  long valid0, long valid1)
+static int __init n2_run(unsigned long io, unsigned long irq,
+			 unsigned long winbase, long valid0, long valid1)
 {
 	card_t *card;
 	u8 cnt, pcr;
+	int i;
 
 	if (io < 0x200 || io > 0x3FF || (io % N2_IOPORTS) != 0) {
 		printk(KERN_ERR "n2: invalid I/O port value\n");
@@ -391,7 +345,7 @@
 		printk(KERN_ERR "n2: invalid IRQ value\n");
 		return -ENODEV;
 	}
-    
+
 	if (winbase < 0xA0000 || winbase > 0xFFFFF || (winbase & 0xFFF) != 0) {
 		printk(KERN_ERR "n2: invalid RAM value\n");
 		return -ENODEV;
@@ -451,26 +405,28 @@
 	pcr = PCR_ENWIN | PCR_VPM | (USE_BUS16BITS ? PCR_BUS16 : 0);
 	outb(pcr, io + N2_PCR);
 
-	cnt = n2_count_page(card);
-	if (!cnt) {
-		printk(KERN_ERR "n2: memory test failed.\n");
+	card->ram_size = sca_detect_ram(card, card->winbase, MAX_RAM_SIZE);
+
+	/* number of TX + RX buffers for one port */
+	i = card->ram_size / ((valid0 + valid1) * (sizeof(pkt_desc) +
+						   HDLC_MAX_MRU));
+
+	card->tx_ring_buffers = min(i / 2, MAX_TX_BUFFERS);
+	card->rx_ring_buffers = i - card->tx_ring_buffers;
+
+	card->buff_offset = (valid0 + valid1) * sizeof(pkt_desc) *
+		(card->tx_ring_buffers + card->rx_ring_buffers);
+
+	printk(KERN_INFO "n2: RISCom/N2 %u KB RAM, IRQ%u, "
+	       "using %u TX + %u RX packets rings\n", card->ram_size / 1024,
+	       card->irq, card->tx_ring_buffers, card->rx_ring_buffers);
+
+	if (card->tx_ring_buffers < 1) {
+		printk(KERN_ERR "n2: RAM test failed\n");
 		n2_destroy_card(card);
 		return -EIO;
 	}
 
-	card->ram_size = cnt * USE_WINDOWSIZE;
-
-	/* 4 rings required for 2 ports, 2 rings for one port */
-	card->ring_buffers = card->ram_size /
-		((valid0 + valid1) * 2 * (sizeof(pkt_desc) + HDLC_MAX_MRU));
-
-	card->buff_offset = (valid0 + valid1) * 2 * (sizeof(pkt_desc))
-		* card->ring_buffers;
-
-	printk(KERN_DEBUG "n2: RISCom/N2 %u KB RAM, IRQ%u, "
-	       "using %u packets rings\n", card->ram_size / 1024, card->irq,
-	       card->ring_buffers);
-
 	pcr |= PCR_RUNSCA;		/* run SCA */
 	outb(pcr, io + N2_PCR);
 	outb(0, io + N2_MCR);
@@ -492,7 +448,7 @@
 		spin_lock_init(&port->lock);
 		dev->irq = irq;
 		dev->mem_start = winbase;
-		dev->mem_end = winbase + USE_WINDOWSIZE-1;
+		dev->mem_end = winbase + USE_WINDOWSIZE - 1;
 		dev->tx_queue_len = 50;
 		dev->do_ioctl = n2_ioctl;
 		dev->open = n2_open;
@@ -531,7 +487,7 @@
 		return -ENOSYS;	/* no parameters specified, abort */
 	}
 
-	printk(KERN_INFO "%s (SCA-%s)\n", version, sca_version);
+	printk(KERN_INFO "%s\n", version);
 
 	do {
 		unsigned long io, irq, ram;
@@ -558,7 +514,7 @@
 				break;
 			hw++;
 		}
-      
+
 		if (!valid[0] && !valid[1])
 			break;	/* at least one port must be used */
 
@@ -566,7 +522,7 @@
 			n2_run(io, irq, ram, valid[0], valid[1]);
 
 		if (*hw == '\x0')
-			return 0;
+			return first_card ? 0 : -ENOSYS;
 	}while(*hw++ == ':');
 
 	printk(KERN_ERR "n2: invalid hardware parameters\n");
@@ -602,6 +558,6 @@
 
 MODULE_AUTHOR("Krzysztof Halasa <khc@pm.waw.pl>");
 MODULE_DESCRIPTION("RISCom/N2 serial port driver");
-MODULE_LICENSE("GPL");
+MODULE_LICENSE("GPL v2");
 MODULE_PARM(hw, "s");		/* hw=io,irq,ram,ports:io,irq,... */
 EXPORT_NO_SYMBOLS;
Index: drivers/net/wan/sbni.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sbni.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sbni.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/sbni.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -1552,13 +1552,13 @@
 static u32
 calc_crc32( u32  crc,  u8  *p,  u32  len )
 {
-	register u32  _crc __asm ( "ax" );
+	register u32  _crc;
 	_crc = crc;
 	
 	__asm __volatile (
 		"xorl	%%ebx, %%ebx\n"
-		"movl	%1, %%esi\n" 
-		"movl	%2, %%ecx\n" 
+		"movl	%2, %%esi\n" 
+		"movl	%3, %%ecx\n" 
 		"movl	$crc32tab, %%edi\n"
 		"shrl	$2, %%ecx\n"
 		"jz	1f\n"
@@ -1594,7 +1594,7 @@
 		"jnz	0b\n"
 
 	"1:\n"
-		"movl	%2, %%ecx\n"
+		"movl	%3, %%ecx\n"
 		"andl	$3, %%ecx\n"
 		"jz	2f\n"
 
@@ -1619,9 +1619,9 @@
 		"xorb	2(%%esi), %%bl\n"
 		"xorl	(%%edi,%%ebx,4), %%eax\n"
 	"2:\n"
-		:
-		: "a" (_crc), "g" (p), "g" (len)
-		: "ax", "bx", "cx", "dx", "si", "di"
+		: "=a" (_crc)
+		: "0" (_crc), "g" (p), "g" (len)
+		: "bx", "cx", "dx", "si", "di"
 	);
 
 	return  _crc;
Index: drivers/net/wan/sdla_chdlc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sdla_chdlc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sdla_chdlc.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/sdla_chdlc.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -591,8 +591,7 @@
 	
 
 		if (chdlc_set_intr_mode(card, APP_INT_ON_TIMER)){
-			printk (KERN_INFO "%s: 
-				Failed to set interrupt triggers!\n",
+			printk (KERN_INFO "%s: Failed to set interrupt triggers!\n",
 				card->devname);
 			return -EIO;	
         	}
@@ -1089,13 +1088,11 @@
 	
 	set_bit(0,&chdlc_priv_area->config_chdlc);
 	chdlc_priv_area->config_chdlc_timeout=jiffies;
-	del_timer(&chdlc_priv_area->poll_delay_timer);
 
 	/* Start the CHDLC configuration after 1sec delay.
 	 * This will give the interface initilization time
 	 * to finish its configuration */
-	chdlc_priv_area->poll_delay_timer.expires=jiffies+HZ;
-	add_timer(&chdlc_priv_area->poll_delay_timer);
+	mod_timer(&chdlc_priv_area->poll_delay_timer, jiffies + HZ);
 	return err;
 }
 
@@ -3822,7 +3819,7 @@
 
 void s508_lock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 	spin_lock_irqsave(&card->wandev.lock, *smp_flags);
         if (card->next){
         	spin_lock(&card->next->wandev.lock);
@@ -3834,7 +3831,7 @@
 
 void s508_unlock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
         if (card->next){
         	spin_unlock(&card->next->wandev.lock);
         }
Index: drivers/net/wan/sdla_fr.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sdla_fr.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sdla_fr.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/sdla_fr.c	4 Aug 2004 01:29:24 -0000	1.2
@@ -4541,9 +4541,7 @@
 {
 	fr_channel_t* chan = dev->priv;
 
-	del_timer(&chan->fr_arp_timer);
-	chan->fr_arp_timer.expires = jiffies + (chan->inarp_interval * HZ);
-	add_timer(&chan->fr_arp_timer);
+	mod_timer(&chan->fr_arp_timer, jiffies + (chan->inarp_interval) * HZ);
 	return;
 }
 
@@ -4709,13 +4707,13 @@
 {
 	if (card->hw.type != SDLA_S514){
 
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 		spin_lock_irqsave(&card->wandev.lock, *smp_flags);
 #else
           	disable_irq(card->hw.irq);
 #endif
 	}else{
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 		spin_lock(&card->u.f.if_send_lock);
 #endif
 	}
@@ -4727,13 +4725,13 @@
 {
 	if (card->hw.type != SDLA_S514){
 
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 		spin_unlock_irqrestore (&card->wandev.lock, *smp_flags);
 #else
           	enable_irq(card->hw.irq);
 #endif
 	}else{
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 		spin_unlock(&card->u.f.if_send_lock);
 #endif
 	}
Index: drivers/net/wan/sdla_ppp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sdla_ppp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sdla_ppp.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/sdla_ppp.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -3331,7 +3331,7 @@
 
 void s508_lock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 	spin_lock_irqsave(&card->wandev.lock, *smp_flags);
 #else
 	disable_irq(card->hw.irq);
@@ -3340,7 +3340,7 @@
 
 void s508_unlock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
         spin_unlock_irqrestore(&card->wandev.lock, *smp_flags);
 #else
 	enable_irq(card->hw.irq);
Index: drivers/net/wan/sdla_x25.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sdla_x25.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sdla_x25.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/sdla_x25.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1267,9 +1267,7 @@
 			connect(card);
 			S508_S514_unlock(card, &smp_flags);
 
-			del_timer(&card->u.x.x25_timer);
-			card->u.x.x25_timer.expires=jiffies+HZ;
-			add_timer(&card->u.x.x25_timer);
+			mod_timer(&card->u.x.x25_timer, jiffies + HZ);
 		}
 	}
 	/* Device is not up until the we are in connected state */
Index: drivers/net/wan/sdlamain.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/sdlamain.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/sdlamain.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/sdlamain.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -511,7 +511,7 @@
 	if (!card->configured){
 
 		/* Initialize the Spin lock */
-#if defined(__SMP__) || defined(LINUX_2_4) 
+#if defined(CONFIG_SMP) || defined(LINUX_2_4) 
 		printk(KERN_INFO "%s: Initializing for SMP\n",wandev->name);
 #endif
 
Index: drivers/net/wan/syncppp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/syncppp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/syncppp.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/syncppp.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -33,7 +33,7 @@
  *
  * Version 1.9, Wed Oct  4 18:58:15 MSK 1995
  *
- * $Id: syncppp.c,v 1.1 2004/07/22 19:49:36 joff Exp $
+ * $Id: syncppp.c,v 1.2 2004/08/04 01:29:25 joff Exp $
  */
 #undef DEBUG
 
Index: drivers/net/wan/wanpipe_multppp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/wanpipe_multppp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/wanpipe_multppp.c	22 Jul 2004 19:49:35 -0000	1.1
+++ drivers/net/wan/wanpipe_multppp.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -2358,7 +2358,7 @@
 
 void s508_lock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 	spin_lock_irqsave(&card->wandev.lock, *smp_flags);
         if (card->next){
 		/* It is ok to use spin_lock here, since we
@@ -2372,7 +2372,7 @@
 
 void s508_unlock (sdla_t *card, unsigned long *smp_flags)
 {
-#if defined(__SMP__) || defined(LINUX_2_4)
+#if defined(CONFIG_SMP) || defined(LINUX_2_4)
 	if (card->next){
 		spin_unlock(&card->next->wandev.lock);
 	}
Index: drivers/net/wan/z85230.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/z85230.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/z85230.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/z85230.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1451,7 +1451,6 @@
 	c->tx_next_skb=NULL;
 	c->tx_ptr=c->tx_next_ptr;
 	
-	netif_wake_queue(c->netdevice);
 	if(c->tx_skb==NULL)
 	{
 		/* Idle on */
@@ -1513,7 +1512,6 @@
 			/* ABUNDER off */
 			write_zsreg(c, R10, c->regs[10]);
 			write_zsctrl(c, RES_Tx_CRC);
-//???			write_zsctrl(c, RES_EOM_L);
 	
 			while(c->txcount && (read_zsreg(c,R0)&Tx_BUF_EMP))
 			{		
@@ -1523,6 +1521,10 @@
 
 		}
 	}
+	/*
+	 *	Since we emptied tx_skb we can ask for more
+	 */
+	netif_wake_queue(c->netdevice);
 }
 
 /**
@@ -1540,7 +1542,6 @@
 {
 	struct sk_buff *skb;
 
-	netif_wake_queue(c->netdevice);
 	/* Actually this can happen.*/
 	if(c->tx_skb==NULL)
 		return;
@@ -1795,7 +1796,6 @@
 	z8530_tx_begin(c);
 	spin_unlock_irqrestore(c->lock, flags);
 	
-	netif_wake_queue(c->netdevice);
 	return 0;
 }
 
Index: drivers/net/wan/8253x/8253x.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/8253x.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/8253x.h	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/8253x.h	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,5 +1,5 @@
 /* -*- linux-c -*- */
-/* $Id: 8253x.h,v 1.1 2004/07/22 19:49:36 joff Exp $
+/* $Id: 8253x.h,v 1.2 2004/08/04 01:29:25 joff Exp $
  * sab82532.h: Register Definitions for the Siemens SAB82532 DUSCC
  *
  * Copyright (C) 1997  Eddie C. Dost  (ecd@skynet.be)
Index: drivers/net/wan/8253x/8253xsyn.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/8253xsyn.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/8253xsyn.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/8253xsyn.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,5 +1,5 @@
 /* -*- linux-c -*- */
-/* $Id: 8253xsyn.c,v 1.1 2004/07/22 19:49:36 joff Exp $
+/* $Id: 8253xsyn.c,v 1.2 2004/08/04 01:29:25 joff Exp $
  * 8253xsyn.c: SYNC TTY Driver for the SIEMENS SAB8253X DUSCC.
  *
  * Implementation, modifications and extensions
Index: drivers/net/wan/8253x/8253xtty.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/8253xtty.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/8253xtty.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/8253xtty.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,5 +1,5 @@
 /* -*- linux-c -*- */
-/* $Id: 8253xtty.c,v 1.1 2004/07/22 19:49:36 joff Exp $
+/* $Id: 8253xtty.c,v 1.2 2004/08/04 01:29:25 joff Exp $
  * sab82532.c: ASYNC Driver for the SIEMENS SAB82532 DUSCC.
  *
  * Copyright (C) 1997  Eddie C. Dost  (ecd@skynet.be)
@@ -2384,7 +2384,7 @@
 
 static void inline show_aurora_version(void)
 {
-	char *revision = "$Revision: 1.1 $";
+	char *revision = "$Revision: 1.2 $";
 	char *version, *p;
 	
 	version = strchr(revision, ' ');
Index: drivers/net/wan/8253x/8253xutl.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/8253xutl.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/8253xutl.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/8253xutl.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,5 +1,5 @@
 /* -*- linux-c -*- */
-/* $Id: 8253xutl.c,v 1.1 2004/07/22 19:49:36 joff Exp $
+/* $Id: 8253xutl.c,v 1.2 2004/08/04 01:29:25 joff Exp $
  * 8253xutl.c: SYNC TTY Driver for the SIEMENS SAB8253X DUSCC.
  *
  * Implementation, modifications and extensions
Index: drivers/net/wan/8253x/crc32dcl.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/crc32dcl.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/crc32dcl.h	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/crc32dcl.h	4 Aug 2004 01:29:25 -0000	1.2
@@ -29,7 +29,6 @@
 /****************************************************/
 
 extern void	fn_init_crc_table(void);
-extern unsigned int	fn_calc_memory_chunk_crc32(void *p, unsigned int n_bytes, unsigned int crc);
 extern unsigned int	fn_calc_memory_crc32(void *p, unsigned int n_bytes);
 extern unsigned int	fn_check_memory_crc32(void *p, unsigned int n_bytes, unsigned int crc);
 
Index: drivers/net/wan/8253x/sp502.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/sp502.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/8253x/sp502.h	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/8253x/sp502.h	4 Aug 2004 01:29:25 -0000	1.2
@@ -17,7 +17,7 @@
  *	file: sp502.h
  *	author: bkd
  *	created: 1/21/95
- *	revision info: $Id: sp502.h,v 1.1 2004/07/22 19:49:36 joff Exp $
+ *	revision info: $Id: sp502.h,v 1.2 2004/08/04 01:29:25 joff Exp $
  *	ripped off from: Header: /vol/sources.cvs/dev/acs/include/sp502.h,v 1.4 1996/11/07 21:35:10 bkd Exp 
  *	Used without modification in the multichannel server portion of the Linux driver by Joachim Martillo
  */
@@ -26,7 +26,7 @@
 #define _SP502_H
 
 #ifdef sun
-#   pragma ident "@(#)$Header: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/sp502.h,v 1.1 2004/07/22 19:49:36 joff Exp $"
+#   pragma ident "@(#)$Header: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/8253x/sp502.h,v 1.2 2004/08/04 01:29:25 joff Exp $"
 #endif
 
 /*
Index: drivers/net/wan/lmc/lmc_ioctl.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/lmc/lmc_ioctl.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/lmc/lmc_ioctl.h	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/lmc/lmc_ioctl.h	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,6 +1,6 @@
 #ifndef _LMC_IOCTL_H_
 #define _LMC_IOCTL_H_
-/*	$Id: lmc_ioctl.h,v 1.1 2004/07/22 19:49:36 joff Exp $	*/
+/*	$Id: lmc_ioctl.h,v 1.2 2004/08/04 01:29:25 joff Exp $	*/
 
  /*
   * Copyright (c) 1997-2000 LAN Media Corporation (LMC)
Index: drivers/net/wan/lmc/lmc_main.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/lmc/lmc_main.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/lmc/lmc_main.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/lmc/lmc_main.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -36,7 +36,7 @@
   *
   */
 
-/* $Id: lmc_main.c,v 1.1 2004/07/22 19:49:36 joff Exp $ */
+/* $Id: lmc_main.c,v 1.2 2004/08/04 01:29:25 joff Exp $ */
 
 #include <linux/version.h>
 #include <linux/kernel.h>
Index: drivers/net/wan/lmc/lmc_media.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/lmc/lmc_media.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/lmc/lmc_media.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/lmc/lmc_media.c	4 Aug 2004 01:29:25 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: lmc_media.c,v 1.1 2004/07/22 19:49:36 joff Exp $ */
+/* $Id: lmc_media.c,v 1.2 2004/08/04 01:29:25 joff Exp $ */
 
 #include <linux/version.h>
 #include <linux/config.h>
Index: drivers/net/wan/lmc/lmc_proto.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/lmc/lmc_proto.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/lmc/lmc_proto.c	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/lmc/lmc_proto.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -31,7 +31,7 @@
 #include <linux/interrupt.h>
 #include <linux/pci.h>
 #include <asm/segment.h>
-#include <asm/smp.h>
+#include <linux/smp.h>
 
 #include <linux/in.h>
 #include <linux/if_arp.h>
Index: drivers/net/wan/lmc/lmc_var.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wan/lmc/lmc_var.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wan/lmc/lmc_var.h	22 Jul 2004 19:49:36 -0000	1.1
+++ drivers/net/wan/lmc/lmc_var.h	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,7 +1,7 @@
 #ifndef _LMC_VAR_H_
 #define _LMC_VAR_H_
 
-/* $Id: lmc_var.h,v 1.1 2004/07/22 19:49:36 joff Exp $ */
+/* $Id: lmc_var.h,v 1.2 2004/08/04 01:29:26 joff Exp $ */
 
  /*
   * Copyright (c) 1997-2000 LAN Media Corporation (LMC)
Index: drivers/net/wireless/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/Config.in,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/net/wireless/Config.in	22 Jul 2004 19:49:45 -0000	1.1
+++ drivers/net/wireless/Config.in	1 Dec 2004 23:17:40 -0000	1.4
@@ -14,6 +14,7 @@
 
 if [ "$CONFIG_PCI" = "y" ]; then
    dep_tristate '    Hermes in PLX9052 based PCI adaptor support (Netgear MA301 etc.) (EXPERIMENTAL)' CONFIG_PLX_HERMES $CONFIG_HERMES $CONFIG_EXPERIMENTAL
+   dep_tristate '    Hermes in TMD7160/NCP130 based PCI adaptor support (Pheecom WL-PCI etc.) (EXPERIMENTAL)' CONFIG_TMD_HERMES $CONFIG_HERMES $CONFIG_EXPERIMENTAL
    dep_tristate '    Prism 2.5 PCI 802.11b adaptor support (EXPERIMENTAL)' CONFIG_PCI_HERMES $CONFIG_HERMES $CONFIG_EXPERIMENTAL
 fi
 
@@ -23,11 +24,27 @@
 
    dep_tristate '  Hermes PCMCIA card support' CONFIG_PCMCIA_HERMES $CONFIG_HERMES
    tristate '  Cisco/Aironet 34X/35X/4500/4800 PCMCIA cards' CONFIG_AIRO_CS
+   dep_tristate '  Atmel at76c502/at76c504 PCMCIA cards' CONFIG_PCMCIA_ATMEL $CONFIG_FW_LOADER
 fi
 
+
+bool	 'Include wlan-ng drivers' CONFIG_WLAN_NG  n
+
+if [ "$CONFIG_USB" != "n" ]; then
+	comment 'Wireless USB cards'
+
+   dep_tristate '  Atmel at76c502/at76c504 USB cards' CONFIG_USB_ATMEL $CONFIG_FW_LOADER
+	
+	if [ "$CONFIG_WLAN_NG" = "y" ]; then
+		dep_tristate ' wlan-ng supported USB cards' PRISM2_USB $CONFIG_FW_LOADER
+	fi
+fi
+
+
 # yes, this works even when no drivers are selected
 if [ "$CONFIG_ISA" = "y" -o "$CONFIG_PCI" = "y" -o \
-     "$CONFIG_ALL_PPC" = "y" -o "$CONFIG_PCMCIA" != "n" ]; then
+     "$CONFIG_ALL_PPC" = "y" -o "$CONFIG_PCMCIA" != "n" -o \
+	 "$CONFIG_USB" != "n" ]; then
    define_bool CONFIG_NET_WIRELESS y
 else
    define_bool CONFIG_NET_WIRELESS n
